/**
\addtogroup content
<p>
  For a resource, the content is XML data that is stored in the 
  repository. Different types of resource use different schemas.
</p>
<TABLE class="RuledTable">
  <tr>
    <th>Item</th>
    <th>Schema For Content</th>
  </tr>
  <tr>
    <td>Repository</td>
    <td>\ref RepositoryContent_schema "RepositoryContent schema"</td>
  </tr>
  <tr>
    <td>Application definition resource</td>
    <td>\ref ApplicationDefinition_schema "ApplicationDefinition schema"</td>
  </tr>
  <tr>
    <td>Drawing source resource</td>
    <td>\ref DrawingSource_schema "DrawingSource schema"</td>
  </tr>
  <tr>
    <td>Feature source resource</td>
    <td>\ref FeatureSource_schema "FeatureSource schema"</td>
  </tr>
  <tr>
    <td>Layer definition resource</td>
    <td>\ref LayerDefinition_schema "LayerDefinition schema"</td>
  </tr>
  <tr>
    <td>Load procedure resource</td>
    <td>\ref LoadProcedure_schema "LoadProcedure schema"</td>
  </tr>
  <tr>
    <td>Map definition resource</td>
    <td>\ref MapDefinition_schema "MapDefinition schema"</td>
  </tr>
  <tr>
    <td>Print layout resource</td>
    <td>\ref PrintLayout_schema "PrintLayout schema"</td>
  </tr>
  <tr>
    <td>Symbol definition resource</td>
    <td>\ref SymbolDefinition_schema "SymbolDefinition schema"</td>
  </tr>
  <tr>
    <td>Symbol library resource</td>
    <td>\ref SymbolLibrary_schema "SymbolLibrary schema"</td>
  </tr>
  <tr>
    <td>Web layout resource</td>
    <td>\ref WebLayout_schema "WebLayout schema"</td>
  </tr>
</TABLE>
<h3>See Also</h3>
<p>
<ul>
  <li>
    \link MgResourceService::SetResource SetResource \endlink
  </li>
  <li>
    \link MgResourceService::GetRepositoryContent GetRepositoryContent \endlink
  </li>
  <li>
    \link MgResourceService::GetResourceContent GetResourceContent \endlink
  </li>
  <li>
    \link MgResourceService::UpdateRepository UpdateRepository \endlink
  </li>
    
</ul>

</p>
**/ 